# Greek World Scenario

from CvPythonExtensions import *
import CvUtil
import PyHelpers		# LOQ
import Popup
import pickle			# LOQ 2005-10-12

# globals
gc = CyGlobalContext()
PyPlayer = PyHelpers.PyPlayer	# LOQ

### Constants ###


# initialise player variables to player IDs from WBS
iRome = 0
iPersia = 1
iMacedonia = 2
iEgypt = 3
iIndia = 4
iCelts = 5
iBabylon = 6
iPhoenicia = 7
iIsrael = 8
iGermanic = 9
iScythia = 10
iEtruria = 11
iGreece = 12
iGreekCol = 13
iSeleucia = 14
iParthia = 15 

iNumPlayers = 16

pRome = gc.getPlayer(iRome)
pPersia = gc.getPlayer(iPersia)
pMacedonia = gc.getPlayer(iMacedonia)
pEgypt = gc.getPlayer(iEgypt)
pIndia = gc.getPlayer(iIndia)
pCelts = gc.getPlayer(iCelts)
pBabylon = gc.getPlayer(iBabylon)
pPhoenicia = gc.getPlayer(iPhoenicia)
pIsrael = gc.getPlayer(iIsrael)
pGermanic = gc.getPlayer(iGermanic)
pScythia = gc.getPlayer(iScythia)
pEtruria = gc.getPlayer(iEtruria)
pGreece = gc.getPlayer(iGreece)
pGreekCol = gc.getPlayer(iGreekCol)
pSeleucia = gc.getPlayer(iSeleucia)
pParthia = gc.getPlayer(iParthia)

# initialise unit variables to unit indices from XML
iSettler = 4
iWorker = 5
iChristianMissionary = 11
iSwordsman = 19
iAxeman = 22
iPhalanx = 26
iArcher = 38
iHorseArcher = 46
iCamelArcher = 49
iGalley = 63

# initialise religion variables to religion indices from XML
iJudaism = 0
iChristianity = 1
iZoroastrianism = 2
iHinduism = 3
iMesopotamian = 4
iGreek = 5
iEgyptian = 6



# LOQ 2005-10-12: removed Fates




class RiseRome:

        iSpawnTurn = 500


	def displayWelcomePopup( self ):
		popup = Popup.PyPopup()
		popup.setHeaderString( CyTranslator().getText("TXT_KEY_RISE_ROME_TITLE", ()) )
		popup.setBodyString( CyTranslator().getText("TXT_KEY_RISE_ROME_INTRO", ()) )
		popup.launch()

# ***** LOQ 2005-10-12: begin ***** #
	def setupScriptData( self ):
		"""Initialise the global script data dictionary for usage."""
		# random variables
		scriptDict =	{	'iPunicFate': -1,
					'iJerusalemFate': -1,
					'iPersianFate': -1,
					'iAlexanderFate': -1
				}
		gc.getPlayer(0).setScriptData( pickle.dumps(scriptDict) )


# ***** LOQ 2005-10-12: end ***** #


	def setup(self):
              
             
		# display welcome message
		self.displayWelcomePopup()

			
        def checkTurn(self, iGameTurn):


                #popup to test if conditions are working
		if (iGameTurn >= 0):
                        popup = Popup.PyPopup()
                        popup.setBodyString( '%d punic \n %d jeru \n %d persia \n %d alex' %(self.getPunicFate(), self.getJerusalemFate(), self.getPersianFate(), self.getAlexanderFate()))
                        popup.launch()


		if (iGameTurn > 0):
				popup = Popup.PyPopup()
				popup.setBodyString( '%d test \n Test')
                        popup.launch()

		if (iGameTurn == 1) or (iGameTurn == 30) or (iGameTurn == 60) or (iGameTurn == 90) or (iGameTurn == 120) or (iGameTurn == 150):
                        self.iSpawnTurn = iGameTurn + gc.getGame().getSorenRandNum(28, 'Greek World - Spawn turn range')

		if (iGameTurn == self.iSpawnTurn) and (iGameTurn <= 149):
                        #Scythian spawn
                        tTopLeft = (41, 44)
                        tBottomRight = (63, 59)
                        dummy, plotList = self.squareSearch( tTopLeft, tBottomRight, self.outerSpawn, [] )
                        rndNum = gc.getGame().getSorenRandNum(len(plotList), 'Greek World - Scythia')
                        result = plotList[rndNum]
                        if (result):
                                self.makeUnit(iHorseArcher, iScythia, result, 3)
                                self.makeUnit(iArcher, iScythia, result, 2)
                                self.makeUnit(iSettler, iScythia, result, 1)
                                self.makeUnit(iWorker, iScythia, result, 1)
        		
		if (iGameTurn == self.iSpawnTurn) and (iGameTurn >= 30):
                        #Germanic spawn
                        tTopLeft = (24, 53)
                        tBottomRight = (41, 70)
                        dummy, plotList = self.squareSearch( tTopLeft, tBottomRight, self.outerSpawn, [] )
                        rndNum = gc.getGame().getSorenRandNum(len(plotList), 'Greek World - Germanic tribes')
                        result = plotList[rndNum]
                        if (result):
                                self.makeUnit(iAxeman, iGermanic, result, 4)
                                self.makeUnit(iArcher, iGermanic, result, 2)
                                self.makeUnit(iSettler, iGermanic, result, 1)
                                self.makeUnit(iWorker, iGermanic, result, 1)
        		
		if (iGameTurn == self.iSpawnTurn) and (iGameTurn <= 111):
                        #Celtic spawn
                        tTopLeft = (8, 43)
                        tBottomRight = (43, 62)
                        dummy, plotList = self.squareSearch( tTopLeft, tBottomRight, self.outerSpawn, [] )
                        rndNum = gc.getGame().getSorenRandNum(len(plotList), 'Greek World - Celts')
                        result = plotList[rndNum]
                        if (result):
                                self.makeUnit(iAxeman, iCelts, result, 4)		
                                self.makeUnit(iArcher, iCelts, result, 2)
                                self.makeUnit(iSettler, iCelts, result, 1)
                                self.makeUnit(iWorker, iCelts, result, 1)





                #Pirates from 200BC to 0AD (turn 80 to 120)
		if (iGameTurn >= 80 and iGameTurn <= 120):
                        if (iGameTurn % 4 == 0):
                                tTopLeft = (10, 34)
                                tBottomRight = (51, 46)
                                dummy, plotList = self.squareSearch( tTopLeft, tBottomRight, self.innerSeaSpawn, [] )
                                rndNum = gc.getGame().getSorenRandNum(len(plotList), 'Greek World - Pirates')
                                result = plotList[rndNum]
                                if (result):
                                        self.makeUnit(iGalley, 18, result, 1)



                #Barbarian invasions from 0AD (turn 120)
		if (iGameTurn >= 120 and iGameTurn <= 175):
                        if (iGameTurn % 3 == 0):
                                tTopLeft = (10, 11)
                                tBottomRight = (51, 30)
                                dummy, plotList = self.squareSearch( tTopLeft, tBottomRight, self.outerInvasion, [] )
                                rndNum = gc.getGame().getSorenRandNum(len(plotList), 'Greek World - Barbarians from the South')
                                result = plotList[rndNum]
                                if (result):
                                        self.makeUnit(iCamelArcher, 18, result, 5)
                        if (iGameTurn % 3 == 1):
                                tTopLeft = (20, 41)
                                tBottomRight = (71, 61)
                                dummy, plotList = self.squareSearch( tTopLeft, tBottomRight, self.innerInvasion, [] )
                                rndNum = gc.getGame().getSorenRandNum(len(plotList), 'Greek World - Barbarians from the East')
                                result = plotList[rndNum]
                                if (result):
                                        self.makeUnit(iHorseArcher, 18, result, 7)
                        if (iGameTurn % 3 == 2):
                                tTopLeft = (9, 46)
                                tBottomRight = (43, 72)
                                dummy, plotList = self.squareSearch( tTopLeft, tBottomRight, self.innerInvasion, [] )
                                rndNum = gc.getGame().getSorenRandNum(len(plotList), 'Greek World - Barbarians from the North')
                                result = plotList[rndNum]
                                if (result):
                                        self.makeUnit(iSwordsman, 18, result, 4)
                                        self.makeUnit(iAxeman, 18, result, 5)



                                

		# Christianity by LOQ
		if (iGameTurn == 123):
			city = gc.getMap().plot( tYerushalayim[0], tYerushalayim[1] ).getPlotCity()
			# if Yerushalayim razed
			if city.isNone():
				jewishCityList = []
				for iPlayer in range(iNumPlayers):
					for pyCity in PyPlayer(iPlayer).getCityList():
						if pyCity.GetCy().isHasReligion(iJudaism):
							jewishCityList.append(pyCity.GetCy())
				if jewishCityList:
					iCity = gc.getGame().getSorenRandNum(len(jewishCityList), 'Greek World - Birth of Christianity')
					city = jewishCityList[iCity]
			# if Yerushalayim exists or an alternative is found
			if not city.isNone():
				gc.getGame().setHolyCity(iChristianity, city, True)
                        #Christianity spreads
                        tCoords = (city.getX(), city.getY())
                        if (gc.getPlayer(city.getOwner()).isHuman() == 0):
                                self.makeUnit(iChristianMissionary, city.getOwner(), tCoords, 7)
                                
                #Christianity spreads
		if (iGameTurn >= 130) and (iGameTurn <= 170):
			christianCityList = []
 			for iPlayer in range(iNumPlayers):
				for pyCity in PyPlayer(iPlayer).getCityList():
					if pyCity.GetCy().isHasReligion(iChristianity):
						christianCityList.append(pyCity.GetCy())                              
			if christianCityList:
				iCity = gc.getGame().getSorenRandNum(len(christianCityList), 'Greek World - Spread of Christianity')
				city = christianCityList[iCity]
                                tCoords = (city.getX(), city.getY())
                                if (gc.getPlayer(city.getOwner()).isHuman() == 0):
                                        self.makeUnit(iChristianMissionary, city.getOwner(), tCoords, 1)






	def squareSearch( self, tTopLeft, tBottomRight, function, argsList ): #by LOQ
		"""Searches all tile in the square from tTopLeft to tBottomRight and calls function for
		every tile, passing argsList. The function called must return a tuple: (1) a result, (2) if
		a plot should be painted and (3) if the search should continue."""
		tPaintedList = []
		result = None
		for x in range(tTopLeft[0], tBottomRight[0]):
			for y in range(tTopLeft[1], tBottomRight[1]):
				result, bPaintPlot, bContinueSearch = function((x, y), result, argsList)
				if bPaintPlot:			# paint plot
					tPaintedList.append((x, y))
				if not bContinueSearch:		# goal reached, so stop
					return result, tPaintedList
		return result, tPaintedList


	def innerInvasion( self, tCoords, result, argsList ):
		"""Checks validity of the plot at the current tCoords, returns plot if valid (which stops the search).
		Plot is valid if it's hill or flatlands and it isn't occupied by a unit or city"""
		bPaint = True
		bContinue = True
		pCurrent = gc.getMap().plot( tCoords[0], tCoords[1] )
		if ( pCurrent.isHills() or pCurrent.isFlatlands() ):
			if ( not pCurrent.isCity() and not pCurrent.isUnit() ):
        			# this is a good plot, so paint it and continue search
				return (None, bPaint, bContinue)
		# not a good plot, so don't paint it but continue search
		return (None, not bPaint, bContinue)

	def outerInvasion( self, tCoords, result, argsList ):
		"""Checks validity of the plot at the current tCoords, returns plot if valid (which stops the search).
		Plot is valid if it's hill or flatlands, it isn't occupied by a unit or city and if it isn't a civ's territory"""
		bPaint = True
		bContinue = True
		pCurrent = gc.getMap().plot( tCoords[0], tCoords[1] )
		if ( pCurrent.isHills() or pCurrent.isFlatlands() ):
			if ( not pCurrent.isCity() and not pCurrent.isUnit() ):
				if (pCurrent.countTotalCulture() == 0 ):
					# this is a good plot, so paint it and continue search
					return (None, bPaint, bContinue)
		# not a good plot, so don't paint it but continue search
		return (None, not bPaint, bContinue)

	def innerSeaSpawn( self, tCoords, result, argsList ):
		"""Checks validity of the plot at the current tCoords, returns plot if valid (which stops the search).
		Plot is valid if it's water and it isn't occupied by any unit. Unit check extended to adjacent plots"""
		bPaint = True
		bContinue = True
		pCurrent = gc.getMap().plot( tCoords[0], tCoords[1] )
		if ( pCurrent.isWater()):
			if ( not pCurrent.isCity() and not pCurrent.isUnit() ):
                                iClean = 0
                                for x in range(tCoords[0] - 1, tCoords[0] + 2):		# from x-1 to x+1
                                        for y in range(tCoords[1] - 1, tCoords[1] + 2):	# from y-1 to y+1
                                                if (pCurrent.getNumUnits() != 0):
                                                        iClean += 1
                                if ( iClean == 0 ):   
					# this is a good plot, so paint it and continue search
					return (None, bPaint, bContinue)
		# not a good plot, so don't paint it but continue search
		return (None, not bPaint, bContinue)

	def outerSpawn( self, tCoords, result, argsList ):
		"""Checks validity of the plot at the current tCoords, returns plot if valid (which stops the search).
		Plot is valid if it's hill or flatlands, it isn't occupied by a unit or city and if it isn't a civ's territory.
		Unit check extended to adjacent plots"""
		bPaint = True
		bContinue = True
		pCurrent = gc.getMap().plot( tCoords[0], tCoords[1] )
		if ( pCurrent.isHills() or pCurrent.isFlatlands() ):
			if ( not pCurrent.isCity() and not pCurrent.isUnit() ):
                                iClean = 0
                                for x in range(tCoords[0] - 1, tCoords[0] + 2):		# from x-1 to x+1
                                        for y in range(tCoords[1] - 1, tCoords[1] + 2):	# from y-1 to y+1
                                                if (pCurrent.getNumUnits() != 0):
                                                        iClean += 1
                                if ( iClean == 0 ):
                                        if (pCurrent.countTotalCulture() == 0 ):
                                                # this is a good plot, so paint it and continue search
                                                return (None, bPaint, bContinue)
		# not a good plot, so don't paint it but continue search
		return (None, not bPaint, bContinue)


